
/***************************************************************************
                 module classe zdf_avt_avmu_avmv.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 25, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2, YREAL x3,YREAL x4,YREAL x5, YREAL x6,YREAL x7,YREAL x8, YREAL x9,YREAL x10,YREAL x11, YREAL x12,YREAL x13,YREAL x14, YREAL x15,YREAL x16,YREAL x17, YREAL x18, YREAL x19)
{/*    	1	from	bn2_rn2			1  i 	j    k    t
     	2	from	bn2_rn2			1  i+1 	j    k    t
     	3	from	bn2_rn2			1  i 	j+1  k    t

     	4	from	ua			1  i-1 	j    30	  t-1
     	5	from	ua			1  i-1 	j+1  30	  t-1
     	6	from	ua			1  i 	j    30	  t-1
     	7	from	ua			1  i 	j+1  30	  t-1

     	8	from	ua			1  i-1 	j    1	  t-1
     	9	from	ua			1  i-1 	j+1  1	  t-1
     	10	from	ua			1  i 	j    1	  t-1
     	11	from	ua			1  i 	j+1  1	  t-1

     	12	from	va			1  i 	j-1  30	  t-1
     	13	from	va			1  i 	j    30	  t-1
     	14	from	va			1  i+1 	j-1  30	  t-1
     	15	from	va			1  i+1 	j    30	  t-1

     	16	from	va			1  i 	j-1  1	  t-1
     	17	from	va			1  i 	j    1	  t-1
     	18	from	va			1  i+1 	j-1  1	  t-1
     	19	from	va			1  i+1 	j    1	  t-1*/

  //verification calcul exact (Fortran<-->Yao)
  //  int ikbu,ikbv,ikbum1,ikbvm1;
  if(Yt==TU){
    YS1=0.;
    YS2=0.;
    YS3=0.;
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 ){//lbc_lnk ! Lateral boundary conditions on ( avt, avmu, avmv ) 
      YS1=0.;
      YS2=0.;
      YS3=0.;
    } 
    else {
      YS1=avt0*tmask(Yi,Yj,Yk);
      YS2=avm0*umask(Yi,Yj,Yk);
      YS3=avm0*vmask(Yi,Yj,Yk);
      // zdfevd
      if( x1 <= -1.e-12 )
	YS1=avevd*tmask(Yi,Yj,Yk);
      if( x1 <= -1.e-12 ||  x2 <= -1.e-12)
	YS2=avevd*umask(Yi,Yj,Yk);
      if( x1 <= -1.e-12 ||  x3 <= -1.e-12)
	YS3=avevd*vmask(Yi,Yj,Yk);
      
      double zvu,zuv,zecu,zecv;
      if(Yk==1 || Yk==30){
	if(Yi==NX-2){//ikbum1
	  if(Yk==1){
	    zvu= 0.25*(x17+x19+x16+x18);
	    zecu = sqrt(x10*x10 + zvu*zvu + bfeb2);
	    YS2= bfri2 * zecu * fse3uw(Yi,Yj,Yk);//ikbu);
	  }
	}
	else{
	  if(Yk==30){
	    zvu= 0.25*(x13+x15+x12+x14);
	    zecu = sqrt(x6*x6 + zvu*zvu + bfeb2);
	    YS2= bfri2 * zecu * fse3uw(Yi,Yj,Yk);//ikbu);
	  }
	}
	if(Yj==NY-2){//ikbvm1
	  if(Yk==1){
	    zuv  = 0.25*(x10+x8+x11+x9);
	    zecv = sqrt(x17*x17 + zuv*zuv + bfeb2);
	    YS3= bfri2 * zecv * fse3vw(Yi,Yj,Yk);//ikbv);
	  }
	}
	else {
	  if(Yk==30){
	    zuv  = 0.25*(x6+x4+x7+x5);
	    zecv = sqrt(x13*x13 + zuv*zuv + bfeb2);
	    YS3= bfri2 * zecv * fse3vw(Yi,Yj,Yk);//ikbv);
	  }
	}
      }
    }
  }
  //
}

//===========================================================================
//                         methode  backward

backward (YREAL x1, YREAL x2, YREAL x3, YREAL x4, YREAL x5, YREAL x6, YREAL x7,
	  YREAL x8, YREAL x9, YREAL x10, YREAL x11, YREAL x12, YREAL x13, 
	  YREAL x14, YREAL x15,YREAL x16, YREAL x17, YREAL x18, YREAL x19)
{
  YJ1I1=0.;  YJ1I2=0.;  YJ1I3=0.;  YJ1I4=0.;  YJ1I5=0.;  YJ1I6=0.;  YJ1I7=0.;
  YJ1I8=0.;  YJ1I9=0.;  YJ1I10=0.; YJ1I11=0.; YJ1I12=0.; YJ1I13=0.; YJ1I14=0.;
  YJ1I15=0.; YJ1I16=0.; YJ1I17=0.; YJ1I18=0.; YJ1I19=0.;
  
  YJ2I1=0.;  YJ2I2=0.;  YJ2I3=0.;  YJ2I4=0.;  YJ2I5=0.;  YJ2I6=0.;  YJ2I7=0.;
  YJ2I8=0.;  YJ2I9=0.;  YJ2I10=0.; YJ2I11=0.; YJ2I12=0.; YJ2I13=0.; YJ2I14=0.; 
  YJ2I15=0.; YJ2I16=0.; YJ2I17=0.; YJ2I18=0.; YJ2I19=0.;

  YJ3I1=0.;  YJ3I2=0.;  YJ3I3=0.;  YJ3I4=0.;  YJ3I5=0.;  YJ3I6=0.;  YJ3I7=0.;
  YJ3I8=0.;  YJ3I9=0.;  YJ3I10=0.; YJ3I11=0.; YJ3I12=0.; YJ3I13=0.; YJ3I14=0.;
  YJ3I15=0.; YJ3I16=0.; YJ3I17=0.; YJ3I18=0.; YJ3I19=0.;

  if(Yt!=TU){
      if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1){//lbc_lnk ! Lateral boundary conditions on ( avt, avmu, avmv ) 
	YJ1I1=0.;  YJ1I2=0.;  YJ1I3=0.;  YJ1I4=0.;  YJ1I5=0.;  YJ1I6=0.;  YJ1I7=0.;  YJ1I8=0.;  YJ1I9=0.;  YJ1I10=0.;
	YJ1I11=0.; YJ1I12=0.; YJ1I13=0.; YJ1I14=0.; YJ1I15=0.; YJ1I16=0.; YJ1I17=0.; YJ1I18=0.; YJ1I19=0.;
	
	YJ2I1=0.;  YJ2I2=0.;  YJ2I3=0.;  YJ2I4=0.;  YJ2I5=0.;  YJ2I6=0.;  YJ2I7=0.;  YJ2I8=0.;  YJ2I9=0.;  YJ2I10=0.;
	YJ2I11=0.; YJ2I12=0.; YJ2I13=0.; YJ2I14=0.; YJ2I15=0.; YJ2I16=0.; YJ2I17=0.; YJ2I18=0.; YJ2I19=0.;
	
	YJ3I1=0.;  YJ3I2=0.;  YJ3I3=0.;  YJ3I4=0.;  YJ3I5=0.;  YJ3I6=0.;  YJ3I7=0.;  YJ3I8=0.;  YJ3I9=0.;  YJ3I10=0.;
	YJ3I11=0.; YJ3I12=0.; YJ3I13=0.; YJ3I14=0.; YJ3I15=0.; YJ3I16=0.; YJ3I17=0.; YJ3I18=0.; YJ3I19=0.;
      } 
      else {
	//	xtest("zdf_avt_avmu_avmv",YG1,Yt);
	/*	YS1=avt0*tmask(Yi,Yj,Yk);
	YS2=avm0*umask(Yi,Yj,Yk);
	YS3=avm0*vmask(Yi,Yj,Yk);*/
	// zdfevd
	/*	if( x1 <= -1.e-12 )
	  S1=avevd*tmask(Yi,Yj,Yk);
	if( x1 <= -1.e-12 ||  x2 <= -1.e-12)
	  YS2=avevd*umask(Yi,Yj,Yk);
	if( x1 <= -1.e-12 ||  x3 <= -1.e-12)
	YS3=avevd*vmask(Yi,Yj,Yk);*/
	
	double zvu,zuv,zecu,zecv,dzecu_zvu,dzecv_zuv;
	double	dzvu_x16,dzvu_x17,dzvu_x18,dzvu_x19,dzecu_x10,dzecu_x16,dzecu_x17,dzecu_x18,dzecu_x19;
	double  dzvu_x12,dzvu_x13,dzvu_x14,dzvu_x15,dzecu_x6 ,dzecu_x12,dzecu_x13,dzecu_x14,dzecu_x15;
	double  dzuv_x8 ,dzuv_x9 ,dzuv_x10,dzuv_x11,dzecv_x17,dzecv_x8 ,dzecv_x9 ,dzecv_x10,dzecv_x11;
	double  dzuv_x4 ,dzuv_x5 ,dzuv_x6 ,dzuv_x7 ,dzecv_x13,dzecv_x4 ,dzecv_x5 ,dzecv_x6 ,dzecv_x7;

	if(Yk==1 || Yk==30){
	  if(Yi==NX-2){//ikbum1
	    if(Yk==1){
	      zvu= 0.25*(x17+x19+x16+x18);
	      dzvu_x16=0.25;
	      dzvu_x17=0.25;
	      dzvu_x18=0.25;
	      dzvu_x19=0.25;
	      zecu = sqrt(x10*x10 + zvu*zvu + bfeb2);
	      dzecu_x10=x10/zecu;
	      dzecu_zvu=zvu/zecu;
	      dzecu_x16=dzecu_zvu*dzvu_x16;
	      dzecu_x17=dzecu_zvu*dzvu_x17;
	      dzecu_x18=dzecu_zvu*dzvu_x18;
	      dzecu_x19=dzecu_zvu*dzvu_x19;
	      YJ2I10 = bfri2 * dzecu_x10 * fse3uw(Yi,Yj,Yk);
	      YJ2I16 = bfri2 * dzecu_x16 * fse3uw(Yi,Yj,Yk);
	      YJ2I17 = bfri2 * dzecu_x17 * fse3uw(Yi,Yj,Yk);
	      YJ2I18 = bfri2 * dzecu_x18 * fse3uw(Yi,Yj,Yk);
	      YJ2I19 = bfri2 * dzecu_x19 * fse3uw(Yi,Yj,Yk);
	    }
	    //if(Yk==1) YS2= bfri2 * zecu * fse3uw(Yi,Yj,Yk);//ikbu);
	  }
	  else{
	    if(Yk==30){
	      zvu= 0.25*(x13+x15+x12+x14);
	      dzvu_x12=0.25;
	      dzvu_x13=0.25;
	      dzvu_x14=0.25;
	      dzvu_x15=0.25;
	      zecu = sqrt(x6*x6 + zvu*zvu + bfeb2);
	      dzecu_x6 =x6/zecu;
	      dzecu_zvu=zvu/zecu;
	      dzecu_x12=dzecu_zvu*dzvu_x12;
	      dzecu_x13=dzecu_zvu*dzvu_x13;
	      dzecu_x14=dzecu_zvu*dzvu_x14;
	      dzecu_x15=dzecu_zvu*dzvu_x15;
	      YJ2I6  = bfri2 * dzecu_x6  * fse3uw(Yi,Yj,Yk);
	      YJ2I12 = bfri2 * dzecu_x12 * fse3uw(Yi,Yj,Yk);
	      YJ2I13 = bfri2 * dzecu_x13 * fse3uw(Yi,Yj,Yk);
	      YJ2I14 = bfri2 * dzecu_x14 * fse3uw(Yi,Yj,Yk);
	      YJ2I15 = bfri2 * dzecu_x15 * fse3uw(Yi,Yj,Yk);
	      //	      YS2= bfri2 * zecu * fse3uw(Yi,Yj,Yk);//ikbu);
	    }
	  }
	  if(Yj==NY-2){//ikbvm1
	    if(Yk==1){
	      zuv  = 0.25*(x10+x8+x11+x9);
	      dzuv_x8 =0.25;
	      dzuv_x9 =0.25;
	      dzuv_x10=0.25;
	      dzuv_x11=0.25;
	      zecv = sqrt(x17*x17 + zuv*zuv + bfeb2);
	      dzecv_x17 = x17 / zecv;
	      dzecv_zuv = zuv / zecv;
	      dzecv_x8 =dzecv_zuv*dzuv_x8;
	      dzecv_x9 =dzecv_zuv*dzuv_x9;
	      dzecv_x10=dzecv_zuv*dzuv_x10;
	      dzecv_x11=dzecv_zuv*dzuv_x11;
	      YJ3I8  = bfri2 * dzecv_x8  * fse3vw(Yi,Yj,Yk);
	      YJ3I9  = bfri2 * dzecv_x9  * fse3vw(Yi,Yj,Yk);
	      YJ3I10 = bfri2 * dzecv_x10 * fse3vw(Yi,Yj,Yk);
	      YJ3I11 = bfri2 * dzecv_x11 * fse3vw(Yi,Yj,Yk);
	      YJ3I17 = bfri2 * dzecv_x17 * fse3vw(Yi,Yj,Yk);
	    }
	  }
	  else {
	    if(Yk==30){
	      zuv  = 0.25*(x6+x4+x7+x5);
	      dzuv_x4 =0.25;
	      dzuv_x5 =0.25;
	      dzuv_x6 =0.25;
	      dzuv_x7 =0.25;
	      zecv = sqrt(x13*x13 + zuv*zuv + bfeb2);
	      dzecv_x13 = x13 / zecv;
	      dzecv_zuv = zuv / zecv;
	      dzecv_x4 =dzecv_zuv*dzuv_x4;
	      dzecv_x5 =dzecv_zuv*dzuv_x5;
	      dzecv_x6 =dzecv_zuv*dzuv_x6;
	      dzecv_x7 =dzecv_zuv*dzuv_x7;
	      YJ3I4  = bfri2 * dzecv_x4  * fse3vw(Yi,Yj,Yk);
	      YJ3I5  = bfri2 * dzecv_x5  * fse3vw(Yi,Yj,Yk);
	      YJ3I6  = bfri2 * dzecv_x6  * fse3vw(Yi,Yj,Yk);
	      YJ3I7  = bfri2 * dzecv_x7  * fse3vw(Yi,Yj,Yk);
	      YJ3I13 = bfri2 * dzecv_x13 * fse3vw(Yi,Yj,Yk);
	      //	      YS3= bfri2 * zecv * fse3vw(Yi,Yj,Yk);//ikbv);
	    }
	  }
	}
      }
  }
  
}

  //===========================================================================
//*************************  FIN DU MODULE zdf_avt_avmu_avmv   *************************

